



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>python简单实现tftp客户端（基于udp）</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">python简单实现tftp客户端（基于udp）</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-01 22:27:36 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>TFTP（Trivial File Transfer Protocol,简单文件传输协议）是TCP/IP协议族中的一个用来在客户机与服务器之间进行简单文件传输的协议，提供不复杂、开销不大的文件传输服务。端口号为69。</p>
<p>接下来了解下TFTP协议内容，</p>
<p><img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1490158/201902/1490158-20190216175925967-636279812.png" /></p>
<p>1：客户发送和服务端每次通信，都要携带2个字节操作码(包的类型)，</p>
<p>2：模式有三种类型，除了文件名其他基本上固定</p>
<p>　　　　（1）netascii，这是8位的ASCII码形式</p>
<p>　　　　（2）octet，8位源数据类型</p>
<p>　　　　（3）mail这种不在支</p>
<p>3：TFTP支持五种类型的包，根据不同操作不同解析</p>
<p>　　&nbsp; &nbsp; &nbsp;<img referrerpolicy="no-referrer"src="https://img2018.cnblogs.com/blog/1490158/201902/1490158-20190216180330969-842251314.png" /></p>
<p>4：服务端把数据包发送到客户端，包括这次发送块数据的编号和数据一起发送到:客户端</p>
<p>5：客户端接收到数据，要向服务服务</p>
<p>看代码</p>
<div>
<pre class="prettyprint linenums"> from socket import *<br />
 import struct<br />
 import time<br />
 udp_sock = socket(AF_INET,SOCK_DGRAM)  #创建一个socket<br />
 #send_data = 0x01612E706E67006f6374657400<br />
 ip = ("192.168.1.10",69)<br />
 send_data = struct.pack("!H5sb5sb",1,b"a.png",0,b"octet",0)#将数据打包成二进制字符串<br />
 udp_sock.sendto(send_data,ip)#向服务器发送请求下载<br />
 while True:<br />
     data,addr = udp_sock.recvfrom(1024)#接收服务端的数据<br />
     data_len = len(data)<br />
     send_data = struct.unpack("!HH",data[:4])#把二进制转换成数据<br />
     if send_data[0] == 3:#3表示服务端发送过来的数据包<br />
         if send_data[1] == 1:<br />
             f = open("b.png","wb+")<br />
         f.write(data[4:])#数据包前4个字节是操作码和块编号，之后的就是实际数据<br />
         ack_data = struct.pack("!HH",4,send_data[1])#这里的4确认码  send_data[1]是服务端发过来的块编号<br />
         udp_sock.sendto(ack_data,addr)#向服务发送数据表示确认收到数据<br />
         if data_len&lt;516:<br />
             f.close()<br />
             print("下载完成")<br />
             break<br />
     elif send_data[0] == 5:<br />
         print("下载失败")<br />
         break<br />
 udp_sock.close()</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/xq4ygyeq.html">这个图片切换动画只用CSS3实现</a>
		</li>
						<li><a href="https://www.batexi.com/a/oqvj1ryq.html">js打开新页面</a>
		</li>
						<li><a href="https://www.batexi.com/a/m8zlrx1q.html">SQL Server 2000：提示&OpenCurlyDoubleQuote;未与信任SQL SERVER连接相关连&rdquo;错误</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxv3dv9.html">an introduction to conditional random fields</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mg0p28.html">Unicode编码</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wj5mxq.html">SharePoint 2013 开发&mdash;&mdash;开发并部署第一个APP</a>
		</li>
						<li><a href="https://www.batexi.com/a/96opvjv9.html">java基础之：详解内部类（转载）</a>
		</li>
						<li><a href="https://www.batexi.com/a/90vxd3n8.html">MFC中对话框的工具栏的使用</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1zzle9.html">关于Latch</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn13x7x8.html">Oracle 性能优化 &mdash; 统计数据收集&lbrack;Z&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qlmzd709.html">request&period;getParameterValues与request&period;getParameter的差别</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2jx40v8.html">opencv ，亮度调整【【OpenCV入门教程之六】 创建Trackbar &amp;amp&semi; 图像对比度、亮度值调整</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdp561xq.html">Mac os 10&period;11 更新ruby</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyr4yz9.html">SpringBoot01 InteliJ IDEA安装、Maven配置、创建SpringBoot项目、属性配置、多环境配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mexwxpq.html">activeMq 使用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjee428.html">Solr 5&period;5&period;0 &plus; tomcat 7&period;0&period;69 &plus; zookeeper-3&period;4&period;6 Cloud部署</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me16m0q.html">python可视化库 Matplotlib 00 画制简单图像</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpn4kjq.html">结对编程项目&mdash;&mdash;C语言实现WordCount Web化</a>
		</li>
						<li><a href="https://www.batexi.com/a/90r2g649.html">Vue学习-基本指令</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rg3e28.html">Mac走moneky</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/93wx0rzq.html">mysql-5&period;7&period;20</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdkw7e9.html">windows下nginx的安装及使用（转载）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv21vjj9.html">Angular6  Observable&period;fromEvent error&colon; &OpenCurlyDoubleQuote;Invalid event target&rdquo;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8m2en4pq.html">C&num; Global定时执行Global文件aTimer处理</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zyo17d9.html">C&num;生成缩略图&comma;C&num;给图片添加水印</a>
			</li>
						<li><a href="https://www.batexi.com/a/95g0x2mq.html">设置mysql远程连接</a>
			</li>
						<li><a href="https://www.batexi.com/a/93wyyywq.html">AET 本征半导体</a>
			</li>
						<li><a href="https://www.batexi.com/a/qv2127z9.html">oracle 的tnsnames&period;ora，listener&period;ora</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdkowe9.html">Python conda安装 并安装Tensorflow</a>
			</li>
						<li><a href="https://www.batexi.com/a/qlljnkeq.html">DataTable行列转换</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
